package tech.nevets.ngxinstaller;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonObject;

import java.util.Timer;
import java.util.TimerTask;

import static spark.Spark.*;

public class Server {
    private static final Gson GSON = new GsonBuilder().setPrettyPrinting().create();
    public static void main(String[] args) {
        port(8080);
        post("/ngx/create", (req, res) -> {
            JsonObject jsonObject = GSON.fromJson(req.body(), JsonObject.class);
            TextStorage ts = TextStorage.createPaste(jsonObject.get("content").getAsString());
            return "{ \"url\":\"https://api.nevets.tech/ngx/raw/" + ts.getId() + "\" }";
        });
        get("/ngx/raw/*", (req, res) -> {
            String id = req.splat()[0];
            TextStorage ts = TextStorage.getPaste(id);
            return GSON.toJson(ts);
        });


        Timer timer = new Timer();
        TimerTask tt = new GCTask();
        timer.schedule(tt, 0, 60000);
    }

    static class GCTask extends TimerTask {
        @Override
        public void run() {
            TextStorage.garbageCollect();
        }
    }
}
